#ifndef UG_READ_TAB_HH
# define UG_READ_TAB_HH

typedef union{
  double num;                 //** All numbers stored as double floats. **/
  char *str;                  //** Strings, identifiers, etc. **/
  struct ug_read_str *urs;    //** NULL-terminated list of strings. **/
  struct ug_read_double *urd; //** NULL-terminated list of doubles. **/
} YYSTYPE;
# define	TOK_LAYER	257
# define	TOK_DEFINITION	258
# define	TOK_END	259
# define	TOK_VERT	260
# define	TOK_WIRE	261
# define	TOK_FACE	262
# define	TOK_INSTANCE	263
# define	TOK_OC	264
# define	TOK_CC	265
# define	TOK_OS	266
# define	TOK_CS	267
# define	TOK_OP	268
# define	TOK_CP	269
# define	TOK_EOL	270
# define	TOK_COLOR	271
# define	TOK_INCLUDE	272
# define	DOUBLE	273
# define	TRANSFORM	274
# define	IDENT	275
# define	ARRAY	276


extern YYSTYPE ug_readlval;

#endif /* not UG_READ_TAB_HH */
