#include <stdio.h>
#include <CADstuff.h>
#include <StringPack.h>
#include <dl_dxf.h>
#include "dxf_reader.h"

using namespace std;


void print_usage(char *cmdname);


extern void ug_parse(ug_CADSpace &uc, char *filename);

int main(int argc, char **argv)
{
  DL_Dxf dxf_file;
  UG_Builder ug_builder;
  DXF_Reader dxf_reader(&ug_builder);
  bool r;
  string dxf_filename;

  if (argc < 4) {
    print_usage(argv[0]);
    exit(1);
  }


  
  StringPack sp;
  string str1, str2;
  
  
  /*
  str1 = string("ha");
  str2 = string("yep");
  sp.addString(str1, str2);
  str1 = string("that is");
  str2 = string("right");
  sp.addString(str1, str2);
  */

  /*
  str1 = string("ha#yeeeah#great#");
  str2 = string("zing");
  sp.addString(str1, str2);
  str1 = string("doop");
  str2 = string("blahhhh");
  sp.addString(str1, str2);

  printf("test: %s\n",
         sp.serialize().c_str());
  */

  /*
  str1 = string("hohohaaaa#szing!!!#sand_well_maybe##it_will_work#spossibly##");
  sp.deserialize(str1);

  str1 = string("hohohaaaa");
  printf("hohohaaaa gives \"%s\"\n", sp.getString(str1).c_str());

  str1 = string("test_str");
  str2 = string("the_value");
  sp.addString(str1, str2);

  str1 = string("test_int");
  sp.addInt(str1, 1234);

  str1 = string("test_double");
  sp.addDouble(str1, 3.1415926);

  str1 = sp.serialize();
  printf("the string we got is \"%s\"\n", str1.c_str());

  sp.deserialize(str1);

  str1 = string("test_int");
  printf("test_int gives %d\n",
         sp.getInt(str1));


  return 0;
  */


  ug_builder.readLayerFile(argv[3]);

  dxf_filename = string(argv[1]);
  r = dxf_file.in(dxf_filename, &dxf_reader);
  if (!r) {
    printf("waaaah\n");
  }

  ug_builder.writeUGFile(string(argv[2]));
  //dxf_creator.printAttributes();

  return 0;
}

void print_usage(char *cmdname)
{
  fprintf(stdout, "usage:\n");
  fprintf(stdout, "%s <DXF input file> <UG output file> <layer file>\n",
          cmdname);
}
